package com.xhu.controller;

import com.xhu.domain.Person;
import com.xhu.domain.Person1;
import com.xhu.domain.Person2;
import com.xhu.domain.Student;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.util.Date;
import java.util.List;

@Controller//加了这个注解才是控制器
public class MyController1 {
    @RequestMapping("/c1/hello1")//配置控制器的访问路径
    public void helloMVC(){
        System.out.println("hello springmvc!!!");
    }
    @RequestMapping("/c1/param1")//配置控制器的访问路径
    public void simpleParam(String username,int age){
    System.out.println(username+"\n"+age+10);//直接将请求参数封装到方法中，方法内部可以直接获取参数。前提是请求参数名与方法参数名相同
    }
    @RequestMapping("/c1/param2")//配置控制器的访问路径
    public void objectParam(Student student){
        //这时候请求参数名必须与属性名一样，如果其中有一样名字输错了，那么只有这个输错的封装不到参数，其他的还是正常封装
        System.out.println(student);
    }
    @RequestMapping("/c1/param3")//配置控制器的访问路径
    public void objectParam2(Person person){
     //自动封装http://localhost:8080/c1/param3?name=xhu&age=19&sex=female&address.info=beijing&address.postcode=030000
        System.out.println(person);
    }
    @RequestMapping("/c1/param4")//配置控制器的访问路径
    public void listParam(@RequestParam List<String> users){
        //自动封装http://localhost:8080/c1/param4?users=xhu&users=cdu&users=scd
        //SpringMVC不支持将参数封装为对象类型的List集合，但可以封装到有List属性的对象中。详情参考/c1/param6
        System.out.println(users);
    }
    @RequestMapping("/c1/param5")//配置控制器的访问路径
    public void arraysParam(@RequestParam String[] users){
        //自动封装http://localhost:8080/c1/param5?users=xhu&users=cdu
        System.out.println(users[0]);
        System.out.println(users[1]);
    }
    @RequestMapping("/c1/param6")//配置控制器的访问路径
    public void listParam2(Person1 person1){
        //自动封装http://localhost:8080/c1/param6?name=xhu&age=19&sex=female&address[0].info=beijing&address[0].postcode=030000&address[1].info=chengdu&address[1].postcode=040000
        System.out.println(person1);
    }
    @RequestMapping("/c1/param7")//配置控制器的访问路径
    public void mapParam(Person2 person2){
        //和List封装对象一样的思路
        //自动封装http://localhost:8080/c1/param7?name=xhu&age=19&sex=female&address['xhu'].info=beijing&address['xhu'].postcode=030000&address['cdu'].info=chengdu&address['cdu'].postcode=040000
        System.out.println(person2);
    }
    @RequestMapping("/c1/param8")//配置控制器的访问路径
    public void servletParam(HttpServletRequest request, HttpServletResponse response, HttpSession session){
        System.out.println(request.getParameter("name"));
        System.out.println(response.getCharacterEncoding());
        System.out.println(session.getId());
    }
    @RequestMapping("/c1/param9")//配置控制器的访问路径
    public void simpleParam2(Date birthday){
        System.out.println(birthday);
    }
    @RequestMapping("/c1/code")//配置控制器的访问路径
    public void codeParam(String name){
        System.out.println(name);
    }
}
