package com.xhu.controller;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.util.Map;

@Controller
public class MyController2 {
    //如果返回值是void，那么就会跳转到     前缀+方法路径名+后缀     的jsp页面
    @RequestMapping("/helloMVC")
    public void helloMVC(){
        System.out.println("hello springMVC!!!");
    }
    //如果返回值是String，那么就会跳转到    前缀+返回值+后缀       的jsp页面
    @RequestMapping("/c2/hello1")
    public String helloMVC1(){
        System.out.println("hello springMVC!!!");
        return "helloMVC";
    }
    //如果返回值是ModelAndView，那么不仅会跳转到  View  的jsp页面。Model还可以存放数据
    @RequestMapping("/c2/hello2")
    public ModelAndView helloMVC2(){
        System.out.println("hello springMVC!!!");
        //1.创建ModelAndView对象
        ModelAndView modelAndView = new ModelAndView();
        //2.获取Model对象，本质是一个Map
        Map<String, Object> model = modelAndView.getModel();
        //3.使用Model对象，向request域设置数据
        model.put("name","xhu");
        model.put("name2","cdu");
        //4.使用View对象设置跳转路径
        modelAndView.setViewName("hello");
        return modelAndView;
    }




    /*
    设置数据的方式
    * */
    @RequestMapping("/c2/hello3")
    public String helloMVC3(HttpServletRequest request){
         request.setAttribute("name","西华大学");
        return "hello";
    }
    @RequestMapping("/c2/hello4")
    public String helloMVC4(Model model, ModelMap modelMap){
        model.addAttribute("name","成都大学");
        modelMap.addAttribute("name2","西华大学");
        return "hello";
    }
    @RequestMapping("/c2/hello5")
    public String helloMVC5(Map map){
        map.put("name","四川大学");
        return "hello";
    }
    @RequestMapping("/c2/hello6")
    public String helloMVC6(HttpSession session){
        session.setAttribute("name","电子科大");
        return "hello";
    }
    @RequestMapping("/c2/hello7")
    public String helloMVC7(HttpSession session){
        ServletContext servletContext = session.getServletContext();
        session.setAttribute("name","电子科大");
        servletContext.setAttribute("name2","四川大学");
        return "hello";
    }







    //跳转方式
    @RequestMapping("/c2/hello8")
    public void helloMVC8(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
         request.setAttribute("name","西华记忆");
         request.getRequestDispatcher("/c2/hello9").forward(request,response);
    }
    @RequestMapping("/c2/hello9")
    public void helloMVC9(HttpServletRequest request, HttpServletResponse response){
        System.out.println("跳转成功");
        System.out.println(request.getAttribute("name"));
    }
    @RequestMapping("/c2/hello10")
    public void helloMVC10(HttpServletRequest request, HttpServletResponse response) throws IOException {
        request.setAttribute("name","西华记忆");
        response.sendRedirect("/c2/hello9");
    }
    @RequestMapping("/c2/hello11")
    public String helloMVC11(HttpServletRequest request){
        request.setAttribute("name","西华记忆");
        return "forward:/c2/hello9";//请求转发 SpringMVC原生自带
    }
    @RequestMapping("/c2/hello12")
    public String helloMVC12(HttpServletRequest request){
        request.setAttribute("name","西华记忆");
        return "redirect:/c2/hello9";//重定向 SpringMVC原生自带
    }

}
