package com.xhu.controller;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.util.Map;

@Controller
@RequestMapping("/c3")
public class MyController3 {
    @RequestMapping(value = "/annotation1",method = RequestMethod.POST)//设置访问方式，不能直接用url地址提交
     public String annotation(String username){
         System.out.println(username);
         return "hello";
     }
    @RequestMapping(value = "/annotation1",
            method = {RequestMethod.POST,RequestMethod.GET},
            params = {"username"},
            headers = {"User-agent"}) //params访问时必须添加的参数，否则报错//headers:规定请求必须包含的请求头
    public String annotation1(String username){
        System.out.println(username);
        return "hello";
    }
    @RequestMapping("/annotation2")
    public String annotation2(@RequestParam(value = "username",defaultValue = "西华大学",required = false)String name){
        //相当于取别名，用username也能获取了，如果没有传参数defaultValue就是默认参数
        //@RequestParam被设置后就必须在访问时传递参数，否则就设置required = false来避免
        System.out.println(name);
        return "hello";
    }
    @RequestMapping("/annotation3")
    public String annotation3(@RequestHeader("User-Agent") String userAgent,
                              @CookieValue("JSESSIONID") String jSessionId){
        System.out.println(userAgent);
        System.out.println(jSessionId);
        return "hello";
    }
}
